import { Cell, Tile, ExtrudeSettings } from '../components';
import * as THREE from 'three';
export declare class Grid {
    cellShape: THREE.Shape;
    cellGeo: THREE.Geometry;
    cellShapeGeo: THREE.ShapeGeometry;
    cellSize: number;
    cells: Array<Cell>;
    numCells: number;
    _cellWidth: number;
    _cellLength: number;
    _hashDelimeter: string;
    _directions: Array<Cell>;
    _diagonals: Array<Cell>;
    _list: Array<any>;
    _vec3: THREE.Vector3;
    _cel: Cell;
    _conversionVec: THREE.Vector3;
    _geoCache: Array<THREE.ExtrudeGeometry>;
    _matCache: Array<any>;
    extrudeSettings: ExtrudeSettings;
    TWO_THIRDS: number;
    constructor(config: any);
    _cubeRound(h: Cell): Cell;
    _createVertex(i: any): THREE.Vector3;
    cellToPixel(cell: Cell): THREE.Vector3;
    cellToHash(cell: Cell): string;
    remove(cell: Cell): void;
    add(cell: Cell): Cell;
    generate(): void;
    pixelToCell(pos: THREE.Vector3): Cell;
    distance(cellA: Cell, cellB: Cell): number;
    clearPath(): void;
    traverse(cb: Function): void;
    getNeighbors(cell: Cell, diagonal: any, filter: any): any[];
    getCellAt(pos: THREE.Vector3): any;
    generateOverlay(size: any, overlayObj: any, overlayMat: any): void;
    generateTile(cell: Cell, scale: any, material: any): Tile;
    generateTiles(): any[];
    dispose(): void;
}
